use std::fs;

use scan_fmt::scan_fmt;
#[allow(dead_code)]
const MINUTES: u32 = 24;

#[allow(dead_code)]
pub fn solve() {
    let path = "res/19/input.txt";

    let contents = fs::read_to_string(path).expect("I/O error, wrong path?");

    // parse blueprints
    let _blueprints: Vec<Blueprint> = contents
        .lines()
        .filter(|line| *line != "")
        .map(|line| {
            let (id,ore,clay,obs1,obs2,geode1,geode2) =
                scan_fmt!(
                    line,
                    "Blueprint {d}: Each ore robot costs {d} ore. Each clay robot costs {d} ore. Each obsidian robot costs {d} ore and {d} clay. Each geode robot costs {d} ore and {d} obsidian.", 
                    u32, u32, u32, u32, u32, u32, u32
                ).unwrap() ;
            Blueprint {
                id,
                ore_bot: ore,
                clay_bot: clay,
                obsidian_bot: (obs1, obs2),
                geode_bot: (geode1, geode2)
            }
        })
        .collect();
}

#[allow(dead_code)]
#[derive(Debug)]
struct Blueprint {
    id: u32,
    ore_bot: u32,
    clay_bot: u32,
    // (ore, clay)
    obsidian_bot: (u32, u32),
    // (ore, obsidian)
    geode_bot: (u32, u32),
}

#[allow(dead_code)]
impl Blueprint {
    pub fn quality_level(&self) -> u32 {
        // TODO dynamic programming?

        return self.id * 1; // TODO largest number of geodes that can be opened
    }
}
